import java.io.StringReader;
import java.util.Scanner;

/** 
 *  Demonstrates how to use the Scanner with command line arguments.
 *  
 *  @author Nick Howe, modified by Sara Sheehan (TODO change to your name)
 *  @version February 24, 2016
 */
public class ShuntYardStub {
	
    /** Pattern that matches on words */
    public static final String WORD = "[a-zA-Z]*\\b";

    /** Pattern that matches on arithmetic operators */
    public static final String OPERATOR = "[^\\w]";

    /** Main method to evaluate expression */
    public static void main(String[] args) {
    	
    		// tell the user how to run the program
    		if (args.length==0) {
    			System.err.println("Usage: java ShuntYardStub <expr>");
	
    		} else {
    			System.out.println("input: " + args[0]);
    			Scanner input = new Scanner(new StringReader(args[0]));
	    
    			// Below is a complicated regular expression that will split the
    			// input string at various boundaries.
    			input.useDelimiter("(\\s+"                  // whitespace
    					+"|(?<=[a-zA-Z])(?=[^a-zA-Z])"      // word->non-word
    					+"|(?<=[^a-zA-Z])(?=[a-zA-Z])"      // non-word->word
    					+"|(?<=[^0-9\\056])(?=[0-9\\056])"  // non-number->number
    					+"|(?<=[0-9\\056])(?=[^0-9\\056])"  // number->non-number
    					+"|(?<=[^\\w])(?=[^\\w]))");        // symbol->symbol
	    
    			// loop to run through all the tokens of the input
    			while (input.hasNext()) {
    				if (input.hasNextDouble()) {
    				    System.out.println("Number: " + input.nextDouble());
    				} else if (input.hasNext(WORD)) {
    				    System.out.println("Word: " + input.next(WORD));
    				} else if (input.hasNext(OPERATOR)) {
    				    System.out.println("Operator: " + input.next(OPERATOR));
    				} else {
    				    System.out.println("Unknown: " + input.next());
    				}
    			}
    		}
    }
}

